// Auto-generated by avdl-compiler v1.3.25 (https://github.com/keybase/node-avdl-compiler)
//   Input file: avdl/keybase1/notify_fs.avdl

package keybase1

import (
	"github.com/keybase/go-framed-msgpack-rpc/rpc"
	context "golang.org/x/net/context"
)

type FSActivityArg struct {
	Notification FSNotification `codec:"notification" json:"notification"`
}

type FSPathUpdatedArg struct {
	Path string `codec:"path" json:"path"`
}

type FSSyncActivityArg struct {
	Status FSPathSyncStatus `codec:"status" json:"status"`
}

type FSEditListResponseArg struct {
	Edits     FSFolderEditHistory `codec:"edits" json:"edits"`
	RequestID int                 `codec:"requestID" json:"requestID"`
}

type FSSyncStatusResponseArg struct {
	Status    FSSyncStatus `codec:"status" json:"status"`
	RequestID int          `codec:"requestID" json:"requestID"`
}

type NotifyFSInterface interface {
	FSActivity(context.Context, FSNotification) error
	FSPathUpdated(context.Context, string) error
	FSSyncActivity(context.Context, FSPathSyncStatus) error
	FSEditListResponse(context.Context, FSEditListResponseArg) error
	FSSyncStatusResponse(context.Context, FSSyncStatusResponseArg) error
}

func NotifyFSProtocol(i NotifyFSInterface) rpc.Protocol {
	return rpc.Protocol{
		Name: "keybase.1.NotifyFS",
		Methods: map[string]rpc.ServeHandlerDescription{
			"FSActivity": {
				MakeArg: func() interface{} {
					var ret [1]FSActivityArg
					return &ret
				},
				Handler: func(ctx context.Context, args interface{}) (ret interface{}, err error) {
					typedArgs, ok := args.(*[1]FSActivityArg)
					if !ok {
						err = rpc.NewTypeError((*[1]FSActivityArg)(nil), args)
						return
					}
					err = i.FSActivity(ctx, typedArgs[0].Notification)
					return
				},
				MethodType: rpc.MethodNotify,
			},
			"FSPathUpdated": {
				MakeArg: func() interface{} {
					var ret [1]FSPathUpdatedArg
					return &ret
				},
				Handler: func(ctx context.Context, args interface{}) (ret interface{}, err error) {
					typedArgs, ok := args.(*[1]FSPathUpdatedArg)
					if !ok {
						err = rpc.NewTypeError((*[1]FSPathUpdatedArg)(nil), args)
						return
					}
					err = i.FSPathUpdated(ctx, typedArgs[0].Path)
					return
				},
				MethodType: rpc.MethodNotify,
			},
			"FSSyncActivity": {
				MakeArg: func() interface{} {
					var ret [1]FSSyncActivityArg
					return &ret
				},
				Handler: func(ctx context.Context, args interface{}) (ret interface{}, err error) {
					typedArgs, ok := args.(*[1]FSSyncActivityArg)
					if !ok {
						err = rpc.NewTypeError((*[1]FSSyncActivityArg)(nil), args)
						return
					}
					err = i.FSSyncActivity(ctx, typedArgs[0].Status)
					return
				},
				MethodType: rpc.MethodNotify,
			},
			"FSEditListResponse": {
				MakeArg: func() interface{} {
					var ret [1]FSEditListResponseArg
					return &ret
				},
				Handler: func(ctx context.Context, args interface{}) (ret interface{}, err error) {
					typedArgs, ok := args.(*[1]FSEditListResponseArg)
					if !ok {
						err = rpc.NewTypeError((*[1]FSEditListResponseArg)(nil), args)
						return
					}
					err = i.FSEditListResponse(ctx, typedArgs[0])
					return
				},
				MethodType: rpc.MethodNotify,
			},
			"FSSyncStatusResponse": {
				MakeArg: func() interface{} {
					var ret [1]FSSyncStatusResponseArg
					return &ret
				},
				Handler: func(ctx context.Context, args interface{}) (ret interface{}, err error) {
					typedArgs, ok := args.(*[1]FSSyncStatusResponseArg)
					if !ok {
						err = rpc.NewTypeError((*[1]FSSyncStatusResponseArg)(nil), args)
						return
					}
					err = i.FSSyncStatusResponse(ctx, typedArgs[0])
					return
				},
				MethodType: rpc.MethodNotify,
			},
		},
	}
}

type NotifyFSClient struct {
	Cli rpc.GenericClient
}

func (c NotifyFSClient) FSActivity(ctx context.Context, notification FSNotification) (err error) {
	__arg := FSActivityArg{Notification: notification}
	err = c.Cli.Notify(ctx, "keybase.1.NotifyFS.FSActivity", []interface{}{__arg})
	return
}

func (c NotifyFSClient) FSPathUpdated(ctx context.Context, path string) (err error) {
	__arg := FSPathUpdatedArg{Path: path}
	err = c.Cli.Notify(ctx, "keybase.1.NotifyFS.FSPathUpdated", []interface{}{__arg})
	return
}

func (c NotifyFSClient) FSSyncActivity(ctx context.Context, status FSPathSyncStatus) (err error) {
	__arg := FSSyncActivityArg{Status: status}
	err = c.Cli.Notify(ctx, "keybase.1.NotifyFS.FSSyncActivity", []interface{}{__arg})
	return
}

func (c NotifyFSClient) FSEditListResponse(ctx context.Context, __arg FSEditListResponseArg) (err error) {
	err = c.Cli.Notify(ctx, "keybase.1.NotifyFS.FSEditListResponse", []interface{}{__arg})
	return
}

func (c NotifyFSClient) FSSyncStatusResponse(ctx context.Context, __arg FSSyncStatusResponseArg) (err error) {
	err = c.Cli.Notify(ctx, "keybase.1.NotifyFS.FSSyncStatusResponse", []interface{}{__arg})
	return
}
